#property strict

//   
#define PRICE_TYPE int

struct PRICE
{
  PRICE_TYPE min;
  PRICE_TYPE max;
  PRICE_TYPE last; //   

  PRICE( void ) : min(INT_MAX), max(INT_MIN)
  {
  }

  const bool operator >( const int Value ) const
  {
    return(this.max > Value);
  }

  const bool operator >=( const int Value ) const
  {
    return(this.max >= Value);
  }

  const bool operator <=( const int Value ) const
  {
    return(this.min <= Value);
  }

  const bool operator >( const PRICE &Price ) const
  {
    return(this.max > Price.max);
  }

  const bool operator <( const PRICE &Price ) const
  {
    return(this.min < Price.min);
  }

  const PRICE operator -( const PRICE &Price ) const
  {
    PRICE Res;

    Res.max = this.max - Price.min;
    Res.min = this.min - Price.max;

    return(Res); //     "=" - 
                 //   const STRUCT,
                 //    const STRUCT
                 //       ,  Res
  }

  const PRICE operator -( void ) const
  {
    PRICE Res;

    Res.min = this.max;
    Res.max = this.min;

    return(Res); //     "=" - 
                 //   const STRUCT,
                 //    const STRUCT
                 //       ,  Res
  }

  template <typename T>
  void operator +=( const T Shift )
  {
    this.min = (PRICE_TYPE)(this.min + Shift);
    this.max = (PRICE_TYPE)(this.max + Shift);
    this.last = (PRICE_TYPE)(this.last + Shift);

    return;
  }

  template <typename T>
  void operator -=( const T Shift )
  {
    this += -Shift;

    return;
  }

  template <typename T>
  const PRICE operator *( const T Shift ) const
  {
    PRICE Res;

    Res.min = (PRICE_TYPE)(this.min * Shift); // typeof  
    Res.max = (PRICE_TYPE)(this.max * Shift);
    Res.last = (PRICE_TYPE)(this.last * Shift);

    return(Res);
  }

  template <typename T>
  void operator *=( const T Shift )
  {
    this = this * Shift;

    return;
  }

  //    ,     -
  // (     )!
  // . http://forum.mql4.com/ru/68681
  void operator =( const PRICE &Value )
  {
//    this = Value; // ,  :  .  Warning. !!!

    //  :   
    this.min = Value.min;
    this.max = Value.max;
    this.last = Value.last;

    return;
  }

  //   ( )  "="     
  void operator =( const PRICE_TYPE Value )
  {
    this.last = Value;

    this.min = this.last;
    this.max = this.last;

    return;
  }

  string ToString( void ) const
  {
    return("min = " + (string)this.min + ", max = " + (string)this.max + ", last = " + (string)this.last);
  }
};