#property strict

#include <BothPrices.mqh>

#property indicator_chart_window
#property indicator_buffers 6

sinput datetime startdate = D'01.07.2015'; //  
extern double markup = 25;                 //  ( + )    
extern bool showvol = FALSE;               //  " " (HighAsk - LowBid)

BOTHPRICES Indicator(startdate, markup / 10000, showvol, TRUE); // TRUE -  

int OnCalculate( const int rates_total,
                 const int prev_calculated,
                 const datetime &time[],
                 const double &open[],
                 const double &high[],
                 const double &low[],
                 const double &close[],
                 const long &tick_volume[],
                 const long &volume[],
                 const int &spread[] )
{
  return(Indicator.Calculate(rates_total, prev_calculated, time, open, high, low, close, tick_volume, volume, spread));
}

void OnChartEvent( const int id, const long& lparam, const double& dparam, const string& sparam )
{
  EVENTBASE::MyEvent(id, lparam, dparam, sparam);

  return;
}

void OnTimer( void )
{
  EVENTBASE::MyEventTimer(); //  

  return;
}

// for ChangeInput:    
#include <ChangeInput.mqh>

void CHANGEINPUT::MyInit( void )
{
  SetGetParameter(" ( + )    ", markup);
  SetGetParameter(" \" \" (HighAsk - LowBid)", showvol);

  return;
}

void OnInit( void )
{
  Indicator.Init(startdate, markup / 10000, showvol);

  EventSetMillisecondTimer(150); //  

  return;
}

void OnDeinit( const int reason )
{
  EventKillTimer();

  return;
}